# coding: utf-8

import logging

from django.conf import settings
from django.contrib.auth.models import User

# from acomea.contact.models import Group
# from acomea.profilo.utils import create_acomeaprofilo_and_rac, get_or_create_contact

from . import models as sso_models
from .utils.sso_client import SSOClient

log = logging.getLogger("acomea.utenti")


class SSOBackend(object):

    def authenticate(self, username=None, password=None):

        if not settings.ACOMEA_SSO_SERVER:
            return None

        username = username.lower() if username else None

        sso_client = SSOClient()

        try:
            sso_login_data = sso_client.login(username, password)
            return sso_models.refresh_or_create_dj_objects(sso_login_data=sso_login_data, password=password)

        except Exception as e:
            return None

    def get_user(self, user_id):
        try:
            return User.objects.get(pk=user_id)
        except User.DoesNotExist:
            return None
